package de.hdm_stuttgart.mi.sd1.test.aufgabe1;

import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.aufgabe1._2_FitnessTarifRechner;

/**
 * <p>Kostenrechner Fitnessstudio.</p>
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
@SuppressWarnings({"UnusedDeclaration"})
public class Test_2_FitnessTarifRechner extends ExaminationTestDefaults {

  /**
   * Kosten ohne Tarifbindung
   */
  @Test public void test_200() {
    Assert.assertEquals(0, _2_FitnessTarifRechner.getKostenOhneTarif((short) 0));
  }
  @Test @Marking(points = 2) public void test_220() {
    Assert.assertEquals(1020, _2_FitnessTarifRechner.getKostenOhneTarif((short) 85));
  }
  @Test @Marking(points = 2) public void test_240() {
    Assert.assertEquals(0, _2_FitnessTarifRechner.getKostenOhneTarif((short) -13));
  }

  /**
   * Kosten im GEMISCHT Tarif
   */
  @Test public void test_260() {
    Assert.assertEquals(_2_FitnessTarifRechner.Tarif.GEMISCHT.jahresKosten,
                        _2_FitnessTarifRechner.getKosten_GEMISCHT_Tarif((short) 0));
  }
  @Test public void test_280() {
    Assert.assertEquals(260, _2_FitnessTarifRechner.getKosten_GEMISCHT_Tarif((short) 22));
    Assert.assertEquals(655, _2_FitnessTarifRechner.getKosten_GEMISCHT_Tarif((short) 101));
  }
  @Test public void test_300() {
    Assert.assertEquals(_2_FitnessTarifRechner.Tarif.GEMISCHT.jahresKosten,
                        _2_FitnessTarifRechner.getKosten_GEMISCHT_Tarif((short) -14));
  }

  // Abschnitt optimale Tarifbestimmung.

  /**
   * Höchste Besuchszahl, bei welcher sich kein Tarifabschluss lohnt.
   */
  @Test
  public void test_400() {
    Assert.assertEquals(_2_FitnessTarifRechner.Tarif.PRO_BESUCH, _2_FitnessTarifRechner.getOptimalenTariftyp((short) 21));
  }
  /**
   * Niedrigste Besuchszahl, bei welcher sich der GEMISCHT lohnt.
   */
  @Test
  public void test_420() {
    Assert.assertEquals(_2_FitnessTarifRechner.Tarif.GEMISCHT, _2_FitnessTarifRechner.getOptimalenTariftyp((short) 22));
  }
  /**
   * Grenztest: 800€ sowohl für GEMISCHT- als auch Ganzjahrestarif.
   */
  @Test public void test_480() {
    Assert.assertEquals(_2_FitnessTarifRechner.Tarif.GEMISCHT, _2_FitnessTarifRechner.getOptimalenTariftyp((short) 130));
  }
  /**
   * Grenztest: Erstmalig ist Flatrate am günstigsten.
   */
  @Test public void test_500() {
    Assert.assertEquals(_2_FitnessTarifRechner.Tarif.JAHRESFLATRATE, _2_FitnessTarifRechner.getOptimalenTariftyp((short) 131));
  }
}
