package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import org.junit.Assert;
import org.junit.Test;
import static de.hdm_stuttgart.mi.sd1.task1.D_ArrayHelper.getSigns;
public class D_ArrayHelperTest extends ExaminationTestDefaults {

    @Test
    public void test_100_null() {
        Assert.assertEquals("", getSigns(null));
    }

    @Test
    public void test_110_empty() {
        Assert.assertEquals("", getSigns(new int[]{}));
    }

    @Test
    public void test_200_positivesSingle() {
        Assert.assertEquals("positives", getSigns(new int[]{1}));
        Assert.assertEquals("positives", getSigns(new int[]{70}));
        Assert.assertEquals("positives", getSigns(new int[]{3000}));
    }

    @Test
    public void test_210_positivesMultiple() {
        Assert.assertEquals("positives", getSigns(new int[]{9, 1, 200, 50}));
        Assert.assertEquals("positives", getSigns(new int[]{10000000, 1000, 999, 8}));
        Assert.assertEquals("positives", getSigns(new int[]{100, 99}));
    }

    @Test
    public void test_300_NegativesSingle() {
        Assert.assertEquals("negatives", getSigns(new int[]{-5}));
        Assert.assertEquals("negatives", getSigns(new int[]{-300}));
        Assert.assertEquals("negatives", getSigns(new int[]{-99999}));
    }

    @Test
    public void test_310_NegativesMultiple() {
        Assert.assertEquals("negatives", getSigns(new int[]{-100, -9}));
        Assert.assertEquals("negatives", getSigns(new int[]{-1, -3, -5, -7}));
    }

    @Test
    public void test_400_justZero() {
        Assert.assertEquals("zeroes", getSigns(new int[]{0}));
    }

    @Test
    public void test_410_justZeroMultiple() {
        Assert.assertEquals("zeroes", getSigns(new int[]{0, 0}));
        Assert.assertEquals("zeroes", getSigns(new int[]{0, 0, 0}));
        Assert.assertEquals("zeroes", getSigns(new int[]{0, 0, 0, 0}));
        Assert.assertEquals("zeroes", getSigns(new int[]{0, 0, 0, 0, 0}));
    }

    @Test
    public void test_500_mixed() {
        Assert.assertEquals("negatives,zeroes,positives", getSigns(new int[]{3, -1, 0}));
        Assert.assertEquals("zeroes,positives", getSigns(new int[]{55, 9, 0}));
        Assert.assertEquals("negatives,zeroes,positives", getSigns(new int[]{0, -19, 300}));
        Assert.assertEquals("negatives,positives", getSigns(new int[]{42, 9, -17}));
        Assert.assertEquals("negatives,positives", getSigns(new int[]{55, 9, -33, 27, 88, -1000, 9}));
        Assert.assertEquals("negatives,zeroes,positives", getSigns(new int[]{0, -3, 0, 55, 9, 0, 1111}));
    }
}
