package de.hdm_stuttgart.mi.sd1.task1;

/**
 * <p>Valid German traffic light states.</p>
 */
public class A_TrafficLight {
    /**
     * <p>Traffic light state validation.</p>
     *
     * <p>German traffic lights feature three different colours red, yellow and green. Only the following four states
     * are valid:</p>
     *
     * <table style="outline: 2px solid;border-spacing: 10ex 0;">
     *     <caption style="background: lightgrey;text-align: left;"><em>Valid German traffic light states</em></caption>
     *     <tr>
     *         <td style="border: 2px solid black;border-radius: 10px;font-size:40px;background:black;">
     *           <ul>
     *             <li style="color:red;"></li>
     *             <li style="color:black;"></li>
     *             <li style="color:black;"></li>
     *           </ul>
     *         </td>
     *         <td>Wait</td>
     *         <td style="border: 2px solid black;border-radius: 10px;font-size:40px;background:black;">
     *           <ul>
     *             <li style="color:red;"></li>
     *             <li style="color:yellow;"></li>
     *             <li style="color:black;"></li>
     *           </ul>
     *         </td>
     *         <td>Start</td>
     *         <td style="border: 2px solid black;border-radius: 10px;font-size:40px;background:black;">
     *           <ul>
     *             <li style="color:black;"></li>
     *             <li style="color:black;"></li>
     *             <li style="color:green;"></li>
     *           </ul>
     *         </td>
     *         <td>Go</td>
     *         <td style="border: 2px solid black;border-radius: 10px;font-size:40px;background:black;">
     *           <ul>
     *             <li style="color:black;"></li>
     *             <li style="color:yellow;"></li>
     *             <li style="color:black;"></li>
     *           </ul>
     *         </td>
     *         <td>Stop</td>
     *     </tr>
     * </table>
     *
     * <p>On contrary <em>any</em> other pattern due to e.g. broken bulbs or other technical failures is invalid:</p>
     *
     * <table style="outline: 2px solid;border-spacing: 10ex 0;">
     *     <caption style="background:lightgrey;text-align:left;">
     *         <em>Invalid German traffic light state examples</em>
     *     </caption>
     *     <tr>
     *         <td style="border: 2px solid black;border-radius: 10px;font-size:40px;background:black;">
     *           <ul >
     *             <li style="color:red;"></li>
     *             <li style="color:black;"></li>
     *             <li style="color:green;"></li>
     *           </ul>
     *         </td>
     *         <td>
     *             <p>Wait or go?</p>
     *             <p>(Fix my</p>
     *             <p>control</p>
     *             <p>unit!)</p>
     *         </td>
     *         <td style="border: 2px solid black;border-radius: 10px;font-size:40px;background:black;">
     *           <ul >
     *             <li style="color:black;"></li>
     *             <li style="color:black;"></li>
     *             <li style="color:black;"></li>
     *           </ul>
     *         </td>
     *         <td>Broken bulb(s)</td>
     *         <td>...</td>
     *     </tr>
     * </table>
     *
     * @param red <code>true</code> represents »on«, <code>false</code> represents »off«.
     * @param yellow <code>true</code> represents »on«, <code>false</code> represents »off«.
     * @param green <code>true</code> represents »on«, <code>false</code> represents »off«.
     *
     * @return <code>true</code> if in a valid state, <code>false</code> otherwise.
     */
    static public boolean stateIsValid(boolean red, boolean yellow, boolean green) {
        return true; //TODO: Implement me!
    }

    private A_TrafficLight(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
